// Copyright (c) 2021 NetEase, Inc.  All rights reserved.
// Use of this source code is governed by a MIT license that can be
// found in the LICENSE file.

import 'dart:convert';

import 'package:nim_core/nim_core.dart';
import 'package:yunxin_integration_test/yunxin_integration_test.dart';
import 'method_name_value.dart';

class HandleChatroomCase extends HandleBaseCase {
  HandleChatroomCase();

  @override
  Future<ResultBean?> handle(event) async {
    super.handle(event);
    var handled = false;
    var result;
    if (className != 'ChatroomService') {
      return null;
    }
    switch (methodName) {
      case enterChatroom:
        {
          Map map = jsonDecode(params![0])['enterRequest'];
          final ret = await NimCore.instance.chatroomService.enterChatroom(
              NIMChatRoomEnterRequest.fromMap(map.cast<String, dynamic>()));
          result = ret;
          handled = true;
          break;
        }
    }
    if (handled) {
      print('ChatroomServiceTest#$methodName result: ${result.code}');
      handleCaseResult = ResultBean(
        code: result.code,
        data: result.toMap(),
        message: result.errorDetails,
      );
    }
    return handleCaseResult;
  }
}
