// Copyright (c) 2021 NetEase, Inc.  All rights reserved.
// Use of this source code is governed by a MIT license that can be
// found in the LICENSE file.

import 'package:nim_core/nim_core.dart';

const initialize = 'initialize';
const createMessage = 'createMessage';
const sendMessage = 'sendMessage';
const sendTextMessage = 'sendTextMessage';
const sendImageMessage = "sendImageMessage";
const sendAudioMessage = "sendAudioMessage";
const sendVideoMessage = "sendVideoMessage";
const sendLocationMessage = "sendLocationMessage";
const sendFileMessage = "sendFileMessage";
const sendTipMessage = "sendTipMessage";
const sendCustomObjectMessage = "sendCustomObjectMessage";
const sendCustomFileMessage = "sendCustomFileMessage";

/// message
const saveMessage = 'saveMessage';
const updateMessage = 'updateMessage';
const cancelUploadAttachment = 'cancelUploadAttachment';
const resendMessage = 'resendMessage';
const forwardMessage = 'forwardMessage';
const revokeMessage = 'revokeMessage';

/// user
const getUserInfo = 'getUserInfo';
const fetchUserInfoList = 'fetchUserInfoList';
const updateMyUserInfo = 'updateMyUserInfo';
const searchUserIdListByNick = 'searchUserIdListByNick';
const searchUserInfoListByKeyword = 'searchUserInfoListByKeyword';
const getFriendList = 'getFriendList';
const getFriend = 'getFriend';
const addFriend = 'addFriend';
const ackAddFriend = 'ackAddFriend';
const deleteFriend = 'deleteFriend';
const updateFriend = 'updateFriend';
const isMyFriend = 'isMyFriend';
const getBlackList = 'getBlackList';
const addToBlackList = 'addToBlackList';
const removeFromBlackList = 'removeFromBlackList';
const isInBlackList = 'isInBlackList';
const getMuteList = 'getMuteList';
const setMute = 'setMute';
const isMute = 'isMute';

/// auth service
const login = 'login';
const logout = 'logout';

/// chatroom service
const enterChatroom = 'enterChatroom';

final Map<String, Function> funcMap = {
  createTeam: NimCore.instance.teamService.createTeam,
  queryTeamList: NimCore.instance.teamService.queryTeamList,
  searchTeam: NimCore.instance.teamService.searchTeam,
  dismissTeam: NimCore.instance.teamService.dismissTeam,
  passApply: NimCore.instance.teamService.passApply,
  addMembersEx: NimCore.instance.teamService.addMembersEx,
  acceptInvite: NimCore.instance.teamService.acceptInvite,
  getMemberInvitor: NimCore.instance.teamService.getMemberInvitor,
  removeMembers: NimCore.instance.teamService.removeMembers,
  quitTeam: NimCore.instance.teamService.quitTeam,
  queryMemberList: NimCore.instance.teamService.queryMemberList,
  queryTeamMember: NimCore.instance.teamService.queryTeamMember,
  updateMemberNick: NimCore.instance.teamService.updateMemberNick,
  transferTeam: NimCore.instance.teamService.transferTeam,
  addManagers: NimCore.instance.teamService.addManagers,
  removeManagers: NimCore.instance.teamService.removeManagers,
  muteTeamMember: NimCore.instance.teamService.muteTeamMember,
  muteAllTeamMember: NimCore.instance.teamService.muteAllTeamMember,
  queryMutedTeamMembers: NimCore.instance.teamService.queryMutedTeamMembers,
  updateTeam: NimCore.instance.teamService.updateTeam,
  updateTeamFields: NimCore.instance.teamService.updateTeamFields,
  muteTeam: NimCore.instance.teamService.muteTeam,
  searchTeamIdByName: NimCore.instance.teamService.searchTeamIdByName,
  searchTeamsByKeyword: NimCore.instance.teamService.searchTeamsByKeyword,
};

/// team
const createTeam = 'createTeam';
const queryTeamList = 'queryTeamList';
const queryTeam = 'queryTeam';
const searchTeam = 'searchTeam';
const dismissTeam = 'dismissTeam';
const passApply = 'passApply';
const addMembersEx = 'addMembersEx';
const acceptInvite = 'acceptInvite';
const getMemberInvitor = 'getMemberInvitor';
const removeMembers = 'removeMembers';
const quitTeam = 'quitTeam';
const queryMemberList = 'queryMemberList';
const queryTeamMember = 'queryTeamMember';
const updateMemberNick = 'updateMemberNick';
const transferTeam = 'transferTeam';
const addManagers = 'addManagers';
const removeManagers = 'removeManagers';
const muteTeamMember = 'muteTeamMember';
const muteAllTeamMember = 'muteAllTeamMember';
const queryMutedTeamMembers = 'queryMutedTeamMembers';
const updateTeam = 'updateTeam';
const updateTeamFields = 'updateTeamFields';
const muteTeam = 'muteTeam';
const searchTeamIdByName = 'searchTeamIdByName';
const searchTeamsByKeyword = 'searchTeamsByKeyword';
const onTeamListUpdate = 'onTeamListUpdate';
const onTeamListRemove = 'onTeamListRemove';
