// Copyright (c) 2021 NetEase, Inc.  All rights reserved.
// Use of this source code is governed by a MIT license that can be
// found in the LICENSE file.

import 'dart:io';

import 'package:flutter/cupertino.dart';
import 'package:flutter_test/flutter_test.dart';
import 'package:integration_test/integration_test.dart';
import 'package:nim_core_example/main.dart';
import 'package:yunxin_integration_test/yunxin_integration_test.dart';
import 'case/handle_chatroom_case.dart';
import 'case/handle_message_case.dart';
import 'case/handle_team_case.dart';
import 'case/handle_event_subscribe_case.dart';
import 'case/handle_history_message_case.dart';
import 'case/handle_initialize_case.dart';
import 'case/handle_system_message_case.dart';
import 'case/handle_user_case.dart';
import 'case/handle_login_case.dart';
import 'package:nim_core_example/main.dart' as app;
late Socket socket;
var result;
const success = 'success';
const fail = 'fail';

final caseList = [
  HandleInitializeCase(),
  HandleSystemMessageCase(),
  HandleUserCase(),
  HandleLoginCase(),
  HandleTeamCase(),
  HandleEventSubscribeCase(),
  HandleHistoryMessageCase(),
  HandleChatroomCase(),
  HandleMessageCase(),
];

void main() {
  IntegrationTestWidgetsFlutterBinding.ensureInitialized();
  // testWidgets('im flutter UI自动化模板', (WidgetTester tester) async {
  //   app.main();
  //   await tester.pumpAndSettle();
  //   final Finder fab = find.byKey(ValueKey('BackKey'));
  //   await tester.tap(fab);
  //   await Future.delayed(Duration(seconds: 2));
  //   await tester.tap(fab);
  //   await Future.delayed(Duration(seconds: 2));
  //   await tester.tap(fab);
  //   await tester.pumpAndSettle();
  // }, timeout: Timeout(Duration(minutes: 30)));

  group(
    'im flutter',
    () {
      test('im flutter test', () async {
        await IntegratedPermissionHelper.requestPermissions(
            IntegratedConfig.permissions);
        await IntegratedManager.instance.init(
            applicationName: 'nimflutter',
            platform: 'flutter',
            version: '1.0.0',
            /*tag: 'your Branch',*/
            packageId: Platform.isAndroid
                ? 'com.netease.nimflutter.nim_core_example'
                : 'com.netease.nimflutter.nimCoreExample',
            caseList: caseList);
        while (IntegratedManager.instance.socket != null) {
          await Future.delayed(Duration(seconds: 5));
        }
      }, timeout: Timeout(Duration(minutes: 30)));
    },
  );
}
