import UIKit
import Flutter

@UIApplicationMain
@objc class AppDelegate: FlutterAppDelegate {
    
    let documentPath = NSSearchPathForDirectoriesInDomains(FileManager.SearchPathDirectory.documentDirectory,
    FileManager.SearchPathDomainMask.userDomainMask, true)[0]
    
  override func application(
    _ application: UIApplication,
    didFinishLaunchingWithOptions launchOptions: [UIApplication.LaunchOptionsKey: Any]?
  ) -> Bool {
    print("document path : ",documentPath)
    GeneratedPluginRegistrant.register(with: self)
    writeTestFile()
    return super.application(application, didFinishLaunchingWithOptions: launchOptions)
  }
    
    func writeTestFile() {
        let fileNames = ["test.mp4","test.jpg","test.mp3"]
        fileNames.forEach { name in
            didWriteTestFle(name)
        }
    }
    
    func didWriteTestFle(_ name: String){
        
        if  let from = Bundle.main.path(forResource: name, ofType: nil){
            let to = (documentPath as NSString).appendingPathComponent(name)
            let filemanager = FileManager.default
            if filemanager.fileExists(atPath: to) == false {
                do {
                    try filemanager.copyItem(atPath: from, toPath: to)
                } catch let error {
                    print("write test file error : ", error)
                }
            }
        }
    }
}
